"""
Jos Verlinde
https://github.com/Josverl/MicroPython-Bootcamp
Nov 9, 2018

MIT License
https://github.com/Josverl/MicroPython-Bootcamp/blob/master/LICENSE
"""

import socket
import ujson
import urequests

def getforecast(CityID, APIKey):
    # Load information for location 
    url = 'https://api.openweathermap.org/data/2.5/forecast/?id={}&appid={}&units=metric&cnt=8'.format(CityID, APIKey)
    try: 
        # Ask for forecast
        response = urequests.get(url)
        # Extract the json and convert it to a dictionary in one go
        forecast = response.json()
    except:
        print('Could not retrieve the weather forecast')
        # todo error handling
    finally:
        response.close()

    try:
        country = forecast['city']['country']
        city = forecast['city']['name']
        short_forecast = forecast['list'][7]['weather'][0]['main']
        long_forecast = forecast['list'][7]['weather'][0]['description']
        temp = forecast['list'][7]['main']['temp']
        humidity = forecast['list'][7]['main']['humidity']
        return country, city, short_forecast, long_forecast, temp, humidity
    except:
        return "unknown","unknown","unknown","unknown","unknown","unknown"

def getcurrentweather(CityID, APIKey):
    #load information for location 
    url = 'https://api.openweathermap.org/data/2.5/weather?id={}&appid={}&units=metric'.format(CityID, APIKey)
    try:
        # Ask for current weather
        response = urequests.get(url)
        # Extract the json and convert it to a dictionary in one go
        info = response.json()
    except:
        print('Could not retrieve the weather forecast')
        # todo error handling
    finally:
        response.close()
    
    country, city, temp, temp_min, temp_max, short_weather, long_weather = "unknown","unknown",-999,-999,-999,"unknown","unknown"
    try:
        country = info['sys']['country']
        city = info['name']
        temp = info['main']['temp']
        temp_min = info['main']['temp_min']
        temp_max = info['main']['temp_max']
        short_weather = info['weather'][0]['main']
        long_weather = info['weather'][0]['description']
    except:
        pass
    return country, city, temp, temp_min, temp_max, short_weather, long_weather