"""
Modified from original code from
https://github.com/m5stack/M5GO
Aug 14, 2018
"""

import _thread, network, ujson, ubinascii, machine
import utime as time

wlan_sta = network.WLAN(network.STA_IF)
wlan_sta.active(True)

def do_connect(ssid, password):
	if not wlan_sta.isconnected():
		wlan_sta.active(True)
		print('Connecting to WiFi: SSID: ' + ssid + ' PASSWORD: ' + password)
		wlan_sta.connect(ssid, password)
		a=0
		while not wlan_sta.isconnected() and (a < 20) :
			time.sleep_ms(500)
			a+=1
			print('.', end='')
		if wlan_sta.isconnected():
			print('\nConnected. Network config: ', wlan_sta.ifconfig())
			return True
		else:
			print('\nProblem. Not Connected to: ' + ssid)
			return False
	else:
		return True

def auto_connect():
	try:
		if not wlan_sta.isconnected():
			with open("modeconfig.json") as f:
				jdata = ujson.loads(f.read())
				ssid = jdata['wifi']['ssid']
				passwd = jdata['wifi']['password']
				if ssid == '' and passwd == '':
					raise OSError
			if do_connect(ssid, passwd):
				return
			else:
				print('Connection failed!')
				if not wlan_sta.isconnected():
					import wificonfig
					wificonfig.webserver_start()
	except OSError:
		# Web server for connection manager
		import wificonfig
		wificonfig.webserver_start()

def isconnected():
	return wlan_sta.isconnected()